import React from "react";
declare type MapResultToPromise<T> = T extends (...args: infer U) => infer R ? R extends Promise<any> ? (...args: U) => R : (...args: U) => Promise<R> : T;
declare type ToPromiseProps<Props extends Record<string, any>> = {
    [Key in keyof Props]: MapResultToPromise<Props[Key]>;
};
export declare type ThreadProps<Props extends ToPromiseProps<any>> = Props extends ToPromiseProps<infer OriginalProps> ? OriginalProps : never;
export declare type WorkerProps<Props extends Record<string, any>> = ToPromiseProps<React.PropsWithChildren<Props>>;
declare type FunctionComponent<P> = (props: P) => React.ReactElement;
declare type ClassComponent<P> = new (props: P) => React.Component<P, any>;
export declare type AnyComponent<P> = FunctionComponent<P> | ClassComponent<P>;
declare type ExtractProps<TComponentOrTProps> = TComponentOrTProps extends AnyComponent<infer TProps> ? TProps : TComponentOrTProps;
export declare const AsUIComponent: <Component extends FunctionComponent<any> | ClassComponent<any>>(component: Component) => (props: ThreadProps<ExtractProps<Component>>) => JSX.Element;
export {};
